100 REMark Filer utility, using QMenu and Toolkit 2
110 WINDOW #0,512,256,0,0
120 REMark if compiled (or SBASIC), add the following line instead
130 REMark OUTLN #0,512,256,0,0
140 p$ = 'SER1' : REMark printer device
150 RESTORE
160 REMark setup main menu array
170 DATA 11 : REMark number of items in menu
180 DATA 'Delete a file','Copy a file','Copy several files'
190 DATA 'Print a file','View a file','Format a disk','Make directory'
200 DATA 'Rename a file','Execute','Search for string in file','Button'
210 READ nitems% : DIM main_menu$(nitems%-1,18)
220 FOR a = 0 TO nitems%-1 : READ main_menu$(a)
230 REPeat program
240   CLS #0
250   item = LIST_SELECT('MAIN MENU',main_menu$,,4+16,,,,,-1,-1)
260   SELect ON item
270     =-1 : REMark ESC-Quit
280       IF ITEM_SELECT('QUIT','Are you sure?','YES','NO',,,,-1)=1 THEN EXIT program
290     =-2 : REMark ignore OK, we are not using it in this program
300     =0 : DELETE_A_FILE
310     =1 : COPY_FILE
320     =2 : COPY_SEVERAL_FILES
330     =3 : PRINT_A_FILE
340     =4 : VIEW_A_FILE
350     =5 : FORMAT_A_DISK
360     =6 : MAKE_DIRECTORY
370     =7 : RENAME_FILE
380     =8 : EXECUTE_A_FILE
390     =9 : SEARCH_A_FILE
400     =10 : INTO_BUTTON
410   END SELect
420 END REPeat program
430 STOP
440 :
450 DEFine PROCedure DELETE_A_FILE
460   filename$ = FILE_SELECT$('DELETE',,-1,,,,,-1,-1)
470   IF filename$ = "" THEN RETurn
480   IF ITEM_SELECT('DELETE','Delete '&filename$&'-Are you sure?','YES','NO',,,,-1) = 1 THEN DELETE filename$
490 END DEFine DELETE_A_FILE
500 :
510 DEFine PROCedure COPY_FILE
520   filename$ = FILE_SELECT$('COPY',,-1,,,,,-1,-1)
530   IF filename$ = '' THEN RETurn
540   filename2$ = READ_STRING$('COPY',filename$,'Copy to:',41,,,-1)
550   IF filename2$ = '' THEN RETurn
560   IF filename$ == filename2$ THEN REPORT_ERROR -8,,,-1 : RETurn
570   COPY filename$ TO filename2$
580 END DEFine COPY_FILE
590 :
600 DEFine PROCedure COPY_SEVERAL_FILES
610   REMark choose source directory
620   sd$ = DIR_SELECT$('COPY FILES',,,,-1,-1) : IF sd$ = '' : RETurn
630   sdrive$ = sd$(1 TO ('_' INSTR sd$)) : REMark extract drive name
640   lensdir% = LEN(sd$)-LEN(sdrive$) : REMark length of directory name
650   ch = FOP_DIR(sd$) : IF ch < 0 THEN REPORT_ERROR ch,,,-1 : RETurn
660   fp = 14 : REMark position in directory
670   DIM files$(199,36),status%(199) : REMark enough for most things
680   nfiles% = 0 : REMark number of files
690   REPeat loop
700     GET #ch\fp : IF EOF(#ch) : EXIT loop
710     GET #ch,files$(nfiles%)
720     nfiles% = nfiles% + 1 : fp = fp + 64
730     IF nfiles% = 200 : EXIT loop
740   END REPeat loop
750   CLOSE #ch
760   REMark display files for selection, by slicing arrays as necessary
770   item = LIST_SELECT('COPY FILES',files$(0 TO nfiles%-1),status%(0 TO nfiles%-1),4,,,,,-1,-1)
780   IF item = -1 THEN RETurn
790   copyto$ = DIR_SELECT$('COPY TO',,,,-1)
800   IF copyto$ == sd$ THEN REPORT_ERROR -8,,,-1 : RETurn
810   td$ = copyto$(1 TO ('_' INSTR copyto$)) : lentdir% = LEN(copyto$)-LEN(td$)
820   FOR a = 0 TO nfiles% - 1
830     IF status%(a) = 128 THEN
840       PRINT #0,'Copying'!files$(a);'...'
850       COPY sd$&files$(a) TO copyto$&files$(a,lensdir%+1 TO LEN(files$(a)))
860     END IF
870   END FOR a
880 END DEFine COPY_SEVERAL_FILES
890 :
900 DEFine PROCedure PRINT_A_FILE
910   filename$ = FILE_SELECT$('PRINT',,-1,,,,,-1,-1)
920   IF filename$ = '' THEN RETurn
930   p$ = READ_STRING$('PRINT',p$,'Print to where?',41,,,-1)
940   IF p$ = '' THEN RETurn
950   COPY_N filename$ TO p$
960 END DEFine PRINT_A_FILE
970 :
980 DEFine PROCedure VIEW_A_FILE
990   REMark actually, there is a view option in the FILE_SELECT$ menu
1000   REMark but this shows an alternative method
1010   filename$ = READ_STRING$('VIEW',DATAD$,'Enter name of file to view',41+65536,,,-1)
1020   IF filename$ = '' THEN RETurn
1030   VIEW_FILE filename$,,,,-1,-1
1040 END DEFine VIEW_A_FILE
1050 :
1060 DEFine PROCedure FORMAT_A_DISK
1070   filename$ = READ_STRING$('FORMAT',,'Enter drive+medium name',20,,,-1)
1080   IF filename$ = '' THEN RETurn
1090   IF ITEM_SELECT('FORMAT','Format '&filename$&'-Are you sure?','YES','NO',,,,-1) = 1 THEN
1100     PRINT #0,'Formatting ';filename$ : FORMAT #0,filename$
1110   END IF
1120 END DEFine FORMAT_A_DISK
1130 :
1140 DEFine PROCedure MAKE_DIRECTORY
1150   filename$ = READ_STRING$('MAKE DIRECTORY',DATAD$,'Enter directory name:',36,,,-1)
1160   IF filename$ = '' THEN RETurn
1170   MAKE_DIR filename$
1180 END DEFine MAKE_DIRECTORY
1190 :
1200 DEFine PROCedure RENAME_FILE
1210   filename$ = FILE_SELECT$('RENAME',,-1,,,,,-1,-1)
1220   IF filename$ = '' THEN RETurn
1230   filename2$ = READ_STRING$('RENAME',filename$,'Rename '&filename$&' to:',41,,,-1)
1240   IF filename2$ == filename$ THEN REPORT_ERROR -8,,,-1 : RETurn
1250   RENAME filename$ TO filename2$
1260 END DEFine RENAME_FILE
1270 :
1280 DEFine PROCedure EXECUTE_A_FILE
1290   filename$ = FILE_SELECT$('EXECUTE',,-2,,,,,-1,-1)
1300   IF filename$ = '' THEN RETurn
1310   IF FTYP(\filename$) = 1 THEN
1320     EXEC filename$
1330   ELSE
1340     REPORT_ERROR -2,,,-1
1350   END IF
1360 END DEFine EXECUTE_A_FILE
1370 :
1380 DEFine PROCedure SEARCH_A_FILE
1390   REMark there are better ways of doing this, I only wrote it like
1400   REMark this to display the use of the VIEW_FILE menu
1410   filename$ = FILE_SELECT$('FIND',,-1,,,,,-1,-1)
1420   IF filename$ = '' THEN RETurn
1430   t$ = READ_STRING$('FIND',,'Text to search for',,,,-1)
1440   IF t$ = '' THEN RETurn
1450   VIEW_FILE filename$,t$,,,-1,-1
1460 END DEFine SEARCH_A_FILE
1470 :
1480 DEFine PROCedure INTO_BUTTON
1490   BUTTON_WAIT 'FILER',,,-1
1500 END DEFine INTO_BUTTON
