1000 REMark Start of 3-only noughts and crosses test
1010 REMark 01/08/96
1020 win$="3210654098707410852096309510753"
1030 FOR j=1,2: WINDOW #j,512,202,0,0: PAPER #j,0: INK #j,6: CLS #j
1040 CSIZE #0,0,0: INK #0,6: CLS #0
1050 INK 4: PRINT: PRINT: PRINT
1060 CSIZE 1,0: PRINT "  Unlike simple noughts & crosses, which with proper play"
1070 PRINT "  always results in a draw, the outcome in this version is"
1080 PRINT "  not so obvious."\\
1090 PRINT "  The reason being that ";
1100 INK 6: PRINT "ONLY THREE X's or O's ARE ALLOWED ON"\"  THE BOARD.";
1110 INK 4: PRINT "   As you play your fourth, your first ";
1120 INK 6: PRINT "disappears!"\\
1130 INK 4: PRINT "  Have fun - press any key to start.."
1140 INK 6
1150 PAUSE: CLS
1160 draw_board: init
1170 PRINT #0, "X starts - any key to begin..": PAUSE
1180 REPeat play
1190 :
1200  REPeat make_x_move
1210   find_move "X"
1220   check_move
1230   IF NOT wrong: EXIT make_x_move
1240   END REPeat make_x_move
1250  update "X"
1260 :
1270  REPeat make_o_move
1280   find_move "O"
1290   check_move
1300   IF NOT wrong: EXIT make_o_move
1310   END REPeat make_o_move
1320  update "O"
1330 :
1340  END REPeat play
1350 :
1360 :
1370 DEFine PROCedure update(n$)
1380 board%(place,1)=1
1390 IF n$="X"
1400  offset=0: INK 2
1410  ELSE : offset=3: INK 4
1420  END IF 
1430 print_it
1440 IF ox%(1+offset)
1450  spot=ox%(1+offset): board%(spot,1)=0
1460  wipe_it
1470  END IF 
1480 ox%(1+offset)=ox%(2+offset): ox%(2+offset)=ox%(3+offset): ox%(3+offset)=place
1490 IF ox%(1+offset)
1500  check_win
1510  ED F 
1520 END DEFine update
1530 :
1540 :
1550 DEFine PROCedure find_move(n$)
1560 REPeat get_move
1570  CLS #0: PRINT #0, "Which square for ";n$;" ?"
1580  ox_go$=INKEY$(#0,-1)
1590  IF ox_go$ INSTR "123456789"
1600   EXIT get_move
1610   ELSE : clot_message
1620   END IF 
1630  END REPeat get_move
1640 place=ox_go$
1650 END DEFine find_move
1660 :
1670 :
1680 DEFine PROCedure draw_board
1690 CLS
1700 REMark drawing vertical board lines
1710 FOR v=50,58,66,74: LINE v,40 TO v,64
1720 REMark drawing horizontal board lines
1730 FOR h=40,48,56,64: LINE 50,h TO 74,h
1740 END DEFine draw_board
1750 :
1760 :
1770 DEFine PROCedure clear_board
1780 CSIZE 3,0
1790 FOR j=1 TO 9: CURSOR board%(j,2),board%(j,3): PRINT " "
1800 CSIZE 0,0
1810 FOR j=1 TO 9: CURSOR board%(j,2)+100,board%(j,3): PRINT j
1820 END DEFine clear_board
1830 :
1840 :
1850 DEFine PROCedure clot_message
1860 CLS #0: PRINT #0, "Don't mess about!"
1870 PRINT #0, "Pick an empty square numbered 1 to 9 only."
1880 PRINT #0, "Press any key to continue..": PAUSE
1890 END DEFine clot_message
1900 :
1910 :
1920 DEFine PROCedure check_move
1930 wrong=board%(place,1)
1940 IF wrong: clot_message
1950 END DEFine check_move
1960 :
1970 :
1980 DEFine PROCedure print_it
1990 CSIZE 3,0
2000 CURSOR board%(place,2),board%(place,3): PRINT n$: INK 6
2010 CSIZE 0,0
2020 END DEFine print_it
2030 :
2040 :
2050 DEFine PROCedure wipe_it
2060  CSIZE 3,0
2070  CURSOR board%(spot,2),board%(spot,3): PRINT " "
2080  CSIZE 0,0
2090 END DEFine wipe_it
2100 :
2110 :
2120 DEFine PROCedure check_win
2130 FOR j=1 TO 3: win%(j)=ox%(j+offset)
2140 FOR k=1 TO 2
2150  FOR j=1 TO 2
2160   IF win%(j+1)>win%(j)
2170    swap=win%(j): win%(j)=win%(j+1): win%(j+1)=swap
2180    END IF 
2190   END FOR j
2200  END FOR k
2210 line$=win%(1)&win%(2)&win%(3)
2220 IF line$ INSTR win$: win
2230 END DEFine check_win
2240 :
2250 :
2260 DEFine PROCedure win
2270 CLS #0: CSIZE #0,3,0: PRINT #0, "A WIN FOR ";n$
2280 CSIZE #0,0,0: PRINT #0, "Do you want another game?   (y/n)"
2290 REPeat reply
2300  reply$=INKEY$(#0,-1)
2310  IF reply$ INSTR "yn": EXIT reply
2320  END REPeat reply
2330 CLS #0
2340 IF reply$=="y": init: ELSE : CLS: EXIT play
2350 END DEFine win
2360 :
2370 :
2380 DEFine PROCedure init
2390 DIM board%(9,3),ox%(6),win%(3)
2400 RESTORE 
2410 FOR j=1 TO 9
2420 board%(j,1)=0: READ board%(j,2): READ board%(j,3)
2430 END FOR j
2440 clear_board
2450 END DEFine init
2460 :
2470 :
2480 DATA 140,76,162,76,184,76
2490 DATA 140,93,162,93,184,93
2500 DATA 140,109,162,109,184,109
2510 :
2520 :
2530 DEFine PROCedure s
2540 SAVE_O 'flp1_ox3'
2550 END DEFine s
