--------[ Content-type: application/octet-stream; name=devname.asm]--------
* PRINT DEVNAME_USE$('FLP')                     written by Jochen Merz 1997

sys_fsdl	equ	$48
sb.inipr	equ	$110
sb.gtstr	equ	$116
err.ipar	equ	-15
sms.info	equ	0
do.smsq 	equ	1
iod_iolk	equ	$18
iod_dnus	equ	$3C
iod_dnam	equ	$42
bv_rip		equ	$58

section 	sbext

	lea	proc_def,a1	;procedures and function table
	move.w	sb.inipr,a2
	jmp	(a2)		;initialise new procs and functions

proc_def
	dc.w	0		;number of procedures
	dc.w	0		;end of procedures
	dc.w	2		;one long function name
	dc.w	devname_use-*
	dc.b	12,'DEVNAME_USE$'
	dc.w	0		;end of functions

devname_use
	move.w	sb.gtstr,a2
	jsr	(a2)		;get a string
	moveq	#err.ipar,d0
	subq.w	#1,d3		;exactly one?
	bne.s	error
	cmp.w	#3,(a6,a1.l)	;three characters long?
	bne.s	error
	move.l	#$DFDFDF00,d4	;case mask
	and.l	2(a6,a1.l),d4	;get device name - upper case!
	move.b	#'0',d4 	;should be 'dev0'

	moveq	#sms.info,d0	;get system variables
	trap	#do.smsq

	move.l	sys_fsdl(a0),a0 ;filing system device list
	move.l	(a0),a0 	;starts here
	bra.s	into_loop

loop
	cmp.l	iod_dnam+2-iod_iolk(a0),d4 ;right filing system found?
	beq.s	found

into_loop
	move.l	(a0),d0 	;end of list?
	beq.s	error_nf
	move.l	d0,a0		;next entry
	bra.s	loop

found
	move.l	iod_dnus+2-iod_iolk(a0),2(a6,a1.l); current useage

ret_string
	moveq	#1,d4		;return string
	moveq	#0,d0

error
	rts

error_nf
	addq.l	#4,a1		;remove string from stack, but leave length
	clr.w	(a6,a1.l)	;...which is 0 for empty string
	move.l	a1,bv_rip(a6)
	bra.s	ret_string

	end
